%!octave 
%
%       OS : GNU/Linux 4.2.5-1-ARCH 
% COMPILER : GNU Octave, version 4.0.0
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: cn_loss_drvt.m,v 1.1 2016/04/02 14:02:18 mechanoid Exp $


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% значения производной функция ошибки (потери) сети на последнем слое
%
function retval = cn_loss_drvt(l,y,cfg),
   lac=3; % номер ячейки cfg с типом ф-ции активации

   o = cn_activate( l, cfg{end}{lac} ) ; % выход последнего слоя

   switch( cfg{end}{lac} ),

	  case "softmax" % для выхода softmax используем среднюю крос-энтропию
		retval = ( o - y ) ;

	  % case "tanh" case "expsig" case "relu"
	  otherwise % для остальных типов выхода используем среднюю квадратическую ошибку
		d = cn_activate_drvt( l, cfg{end}{lac} ) ; % значение производной ф-ции активации 
		retval = ( o - y ).*d; 

   endswitch

endfunction

