%!octave 
%      
%       OS : GNU/Linux 4.2.5
% COMPILER : GNU Octave, version 4.0.0
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: cn_print_cfg.m,v 1.4 2016/04/11 20:57:00 mechanoid Exp $


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function cn_print_cfg(cfg),
   printf("[i] конфигурация сети: \n");
   printf("\t- - - - - - - - - - \n");
   for i=1:length(cfg),
   	  print_cfg_layer(cfg,i);
   endfor
   printf("\t- - - - - - - - - - \n");
endfunction

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function print_cfg_layer(cfg,n),
   ltp=1; % номер ячейки с типом слоя 

   switch cfg{n}{ltp}

   	  case "input"
		 print_cfg_layer_input( cfg{n} );

	  case "mlp"
		 print_cfg_layer_mlp( cfg{n} );

	  case "conv"
		 print_cfg_layer_conv( cfg{n} );

	  case "mpool"
		 print_cfg_layer_mpool( cfg{n} );

	  otherwise
		 printf("[E] print_cfg_layer: неизвестный тип слоя %s \n",cfg{n}{ltp}); 
		 exit -1;

   endswitch

endfunction


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function print_cfg_layer_mlp(cfg),
   lsz=2; 
   lac=3; 
   printf("\tmlp,\t%i,\t\t%s\n",cfg{lsz},cfg{lac});

endfunction

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function print_cfg_layer_mpool(cfg),
   lsz=2; 
   lac=3; 
   printf("\tmpool,\t%i x %i,\t\t%s\n",cfg{lsz}(1),cfg{lsz}(2),cfg{lac});
endfunction

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function print_cfg_layer_conv(cfg),
   lsz=2; 
   lac=3; 
   lmt=4; 
   printf("\tconv,\t%i x %i x %i,\t%s\n",cfg{lsz}(1),cfg{lsz}(2),size(cfg{lmt},2),cfg{lac});

   m=cfg{lmt} ;
   printf("\t\t- - - - - - - - - - - - - - - - - - - - \n");
   for i=1:size(m,1), 
	  printf("\t\t"); 
	  printf("%i ",m(i,:)); 
	  printf("\n"); 
   endfor
   printf("\t\t- - - - - - - - - - - - - - - - - - - - \n");



endfunction

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function print_cfg_layer_input(cfg),
   lsz=2; 
   lac=3; 
   
   s=cfg{lsz};
   if length(s>2),
	  printf("\tinput,\t%i x %i x %i,\t%s\n",s(1),s(2),s(3),cfg{lac});
   else
	  printf("\tinput,\t%i x %i x 1,\t%s\n",s(1),s(2),cfg{lac});
   endif

endfunction

