%!octave 
%
%
%       OS : GNU/Linux 4.2.5-1-ARCH 
% COMPILER : GNU Octave, version 4.0.0
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: cn_weight_add.m,v 1.9 2016/04/10 20:31:02 mechanoid Exp $


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% a*w1+b*w2
%
function retval = cn_weight_add(w1,w2,a,b,cfg),
   layers_numb = length(w1) ; % количество обрабатывающих слоёв 

   r={};
   for i=1:layers_numb,
      r{i} = weight_add_layer(w1,w2,a,b,cfg,i) ;
   endfor

   retval = r ;
endfunction


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function retval = weight_add_layer(w1,w2,a,b,cfg,n),
   ltp=1; % номер ячейки с типом слоя 

   switch cfg{n+1}{ltp}

	  case "mlp"
	     r = weight_add_mlp( w1{n},w2{n},a,b );

	  case "conv"
	     r = weight_add_conv( w1{n},w2{n},a,b );

	  case "mpool"
	     %r = weight_add_mpool( w1{n},w2{n},a,b );
	     r = weight_add_mlp( w1{n},w2{n},a,b );

	  otherwise
		 printf("[E] weight_add_layer : неизвестный тип слоя %s \n",cfg{n+1}{ltp}); 
		 exit -1;

   endswitch

   retval = r;

endfunction


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function retval = weight_add_mlp( w1n,w2n,a,b ),
   r={};
   r{1} = w1n{1}.* a + w2n{1} .* b ;
   r{2} = w1n{2}.* a + w2n{2} .* b ;
   retval = r ;
endfunction


% % - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% function retval = weight_add_mpool( w1n,w2n,a,b ),
% %    r={};
% %    r{1} = w1n{1}.* a + w2n{1} .* b ;
% %    r{2} = w1n{2}.* a + w2n{2} .* b ;
% %    retval = r ;
% 
%    % этот слой выполняет только выборку максимальных элементов по ячейкам
%    retval = { 1.0, 0.0 } ;
% endfunction

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function retval = weight_add_conv( w1n,w2n,a,b ),
   r={};
   for i=1:length(w1n{1}),
	  r{1}{i} = w1n{1}{i} .* a + w2n{1}{i} .* b ;
   endfor
   r{2} = w1n{2} .* a + w2n{2} .* b ;
   retval = r ;
endfunction



