%!octave 
%
%
%       OS : GNU/Linux 4.2.5
% COMPILER : GNU Octave, version 4.0.0
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: cn_weight_norm.m,v 1.1 2016/04/11 20:57:00 mechanoid Exp $


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% нормируем градиент
%
function retval = cn_weight_norm(g,cfg),
   vg = cn_weight_unpack(g,cfg); 
   ng=norm(vg);

   r={};
   for i=1:length(g),
	  r{i}=weight_norm_layer(g,ng,cfg,i);
   endfor
   retval = r;
endfunction


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function retval = weight_norm_layer(g,ng,cfg,n ),
   ltp=1; % номер ячейки с типом слоя 

   switch cfg{n+1}{ltp}

	  case "mlp"
		 s = weight_norm_mlp( g{n},ng );

	  case "conv"
	     s = weight_norm_conv( g{n},ng );

	  case "mpool"
	     % s = weight_norm_mpool( g{n},ng );
		 s = weight_norm_mlp( g{n},ng );
	  otherwise
		 printf("[E] weight_norm_layer: неизвестный тип слоя %s \n",cfg{n+1}{ltp}); 
		 exit -1;

   endswitch

   retval = s ;
endfunction



% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function retval = weight_norm_mlp(g,ng ),
   s = {} ;
   s{1} = g{1}./ng;
   s{2} = g{2}./ng;
   retval = s ;
endfunction

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function retval = weight_norm_conv(g,ng ),
   s = {} ;
   
   for i=1:length(g{1}),
	  s{1}{i} = g{1}{i}./ng ;
   endfor

   s{2} = g{2}./ng ;
   retval = s ;
endfunction


% 
% % - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% function retval = weight_norm_mpool(g,ng ),
% %  s = {} ;
% %    s{1} = g{1}./ng ;
% %    s{2} = g{2}./ng ;
% %    retval = s ;
% 
%    % этот слой выполняет только выборку максимальных элементов по ячейкам
%    retval = { 1.0 , 0.0 };
% endfunction

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
%
% printf("   mean: %.9f  %.9f, norm: %.9f \n",nmean(g{n}{1}),nmean(g{n}{2}),ng) ; 
% printf("   max: %.9f  %.9f, norm: %.9f \n",nmax(g{n}{1}),nmax(g{n}{2}),ng) ; 
% printf("   min: %.9f  %.9f, norm: %.9f \n",nmin(g{n}{1}),nmin(g{n}{2}),ng) ; 
%
% function retval = nmean(g),
%    m=g; for i=1:ndims(g), m=mean(m) ; endfor
%    retval=m;
% endfunction
% 
% function retval = nmax(g),
%    m=g; for i=1:ndims(g), m=max(m) ; endfor
%    retval=m;
% endfunction
% 
% function retval = nmin(g),
%    m=g; for i=1:ndims(g), m=min(m) ; endfor
%    retval=m;
% endfunction
 
