%!octave 
%
%
%       OS : GNU/Linux 4.2.5-1-ARCH 
% COMPILER : GNU Octave, version 4.0.0
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: cn_weight_unpack.m,v 1.9 2016/04/10 20:31:02 mechanoid Exp $


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% разворачиваем матрицы весов в вектор 
%
function retval = cn_weight_unpack(w,cfg),
   layers_numb = length(w); % количество обрабатывающих слоёв 

   rn=[];rb=[];
   for i=1:layers_numb,
      [ vn, vb ] = weight_unpack_layer(w,cfg,i);

      rn = [ rn ; vn ];
      rb = [ rb ; vb ]; 
   endfor

   retval= [ rn; rb ] ;
endfunction


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function [ vn, vb ] = weight_unpack_layer(w,cfg, n ),
   ltp=1; % номер ячейки с типом слоя 

   switch cfg{n+1}{ltp}

	   case "mlp"
	     [ vn, vb ] = weight_unpack_mlp( w{n} );

	   case "conv"
		 [ vn, vb ] = weight_unpack_conv( w{n} );

	   case "mpool"
		 %[ vn, vb ] = weight_unpack_mpool( w{n} );
	     [ vn, vb ] = weight_unpack_mlp( w{n} );


	  otherwise
		 printf("[E] weight_unpack_layer: неизвестный тип слоя %s \n",cfg{n+1}{ltp}); 
		 exit -1;

   endswitch

endfunction


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function [ vn, vb ] = weight_unpack_mlp(w),
   vn = w{1}(:);
   vb = w{2}(:);
endfunction

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function [ vn, vb ] = weight_unpack_conv(w),
   vn = [] ;
   for i=1:length(w{1}),
	  vn = [ vn ; w{1}{i}(:) ] ;
   endfor

   vb = w{2}(:);
endfunction

% % - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% function [ vn, vb ] = weight_unpack_mpool(w),
%    % vn = w{1}(:); vb = w{2}(:);
%    % этот слой выполняет только выборку максимальных элементов по ячейкам
%    vn = 0.0 ; vb = 0.0 ;
% endfunction

