%!octave 
%
%       OS : GNU/Linux 4.2.5-1-ARCH 
% COMPILER : GNU Octave, version 4.0.0
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: data_load_img.m,v 1.2 2016/04/10 20:31:02 mechanoid Exp $


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% загрузка картинок
%
% lst - список файлов :  имя   класс
%
function retval=data_load_img(lst),
   img_dir = fileparts(lst); % каталог с файлами
   [f,n] = textread (lst,"%s %d"); % загружаем список файлов

   % размер изображения (предполагаем, что все изображения однотипные )
   ff=sprintf("%s/%s",img_dir,f{1}) ;
   xi=img_load(ff) ;
   img_size = size(xi)(1:2);
   if ndims(xi)<3,
	  img_cn = 1 ;
   else
	  img_cn = size(xi)(3)
   endif

   out_size=max(n); % размер выходного вектора (количество нейронов последнего слоя)

   szf=length(f) ;
	  
   X=zeros([ img_size, img_cn, szf ] ) ; 
   Y=zeros( [ out_size, szf ] ) ;

   for i=1:szf,
	  ff=sprintf("%s/%s",img_dir,f{i}) ;
	  xi=img_load(ff);
	  X(:,:,:,i) = xi; 

	  %for j=1:size(xi,3), X(:,:,j,i) = xi(:,:,j); endfor

 	  Y(n(i),i) = 1 ; % выход сети для учебного входа номер i, {0,1}

	  printf("     %i / %i    : %i х %i х %i      \r",i,szf,size(xi,1),size(xi,2),size(xi,3) ) ;
   endfor
   printf("\n") ;

   save("-text","result/x.txt","X");
   save("-text","result/y.txt","Y");
 
   retval={ X,Y,img_size,f,img_cn};
   
endfunction


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function retval=img_load(f),
   im=imread(f) ; % загружаем изображение

   switch( class(im) )
	  case "logical"
		 x = 1.0 - double(im) ;
	  %case 'uint8'
	  otherwise
	     x= 1.0 - lin_corr(double(im),1.0);
   endswitch
 
   %if ndims(x) < 3,
   %	  x = ones([ size(x),3] ) .* x ;
   %endif

   retval = x ;

endfunction


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% split_long_rows(0) ; % set nowrap
% f="data/BMP/30x30-123/training/index.txt"
% cc=data_load_img2(f)
