%!octave 
%
%      
%      
%       OS : GNU/Linux 4.3.3-3-ARCH 
% COMPILER : GNU Octave, version 4.0.0
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: link_matr.m,v 1.3 2016/04/21 14:06:58 mechanoid Exp $


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% карта связей (матрица смежности) свёрточного слоя
%
% m - количество выходных карт
% n - количество входных карт 
% k0 - минимальное количество связей для карты
%
function retval = link_matr(m,n,k0),
   R = ones(n,m) ; % начальная матрица связей

   k = min(k0,n) ; % начальное количество связей
   v = [ ones(k,1) ; zeros(n-k,1) ] ; % изменяемая маска связей
   %for j = 1:m,
   for j = 1:m-1,
	  R(:,j) = v ;
	  v = shift(v,1) ; % изменяем конфигуацию связей
	  if( (j>n*(k-k0+1)-1) && (k<n) ),
		 k+=1; 
		 v=[ ones(k,1) ; zeros(n-k,1) ]; 
	  endif
   endfor
   
   retval=R;

endfunction








% 0   1   2   3   4   5   6   7   8   9  10   11
% 
% 1   +           +   +   +       +   +   +   +
%   
% 2   +   +           +   +   +       +   +   +
% 
% 3   +   +   +           +   +   +       +   +
% 
% 4       +   +   +       +   +   +   +       +
% 
% 5           +   +   +       +   +   +   +   +
% 

% 0   1   2   3   4   5   6   7
%
% 1   +           +       +   +
%
% 2       +       +   +       +
%
% 3           +       +   +   +

%m_in = 3;
%m_out= 7;
% link_matr(m_out,m_in,1)

%link_matr(7,5,3)
