%!octave 
%
%       OS : GNU/Linux 4.2.5
% COMPILER : GNU Octave, version 4.0.0
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: main.m,v 1.26 2016/04/21 19:25:36 mechanoid Exp mechanoid $

addpath("../0-data-proc");

split_long_rows(0) ; % set nowrap

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
printf("[i] загружаем данные\n"); 

[fl,fc,ft ] = data_path_img();

L = data_load_img(fl); % L={ X,Y,img_size,files_list,num_chan}
C = data_load_img(fc); 

printf("[i] загружено %i: учебных: %i контрольных: %i \n",size(L{2},2)+size(C{2},2),size(L{2},2),size(C{2},2));

sz_img = [ L{3}, L{5} ] ; % размер и число каналов входного изображения
sz_out = size(L{2},1) ; % размер выхода сети

% { тип, размер, активация } , активация: lin tanh expsig relu softmax
cfg = {
   { "input", sz_img, "lin"}, % тип, размер, активация 
   { "conv", [ 5,5 ],"relu", link_matr( 10, sz_img(3), 1 ) }, % тип, размер и количество ядер, активация, матрица связей слоёв link_matr(выход,вход,минимальное количество)
%   { "mpool", [ 2,2 ],"lin" }, % тип, размер ячейки выборки, активация
   { "mlp", 100,"relu"}, % тип, размер, активация
   { "mlp", sz_out,"softmax"} % тип, размер, активация
} ;

cn_print_cfg(cfg);

save("-text","result/cfg.txt", "cfg" ) ;

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% обучение MLP

W = cn_init(cfg) ; % save("-text","result/w0.txt", "W" ) ;
save("-text","result/w0.txt", "W" ) ;

printf("[i] обучение ...\n"); 

er=[ 1,1 ];

trn_par = {
   2e-1, % порог допустимой ошибки обучения
   500, % максимальное число эпох
   5,  % размер окна контроля за ошибкой
   1e-1, % параметр скорости обучения
   1e-2, % параметр момента 
   0.0, % параметр регуляризации
   0.8, % доля учебных примеров в одном пакете от общего количества примеров
   1  % печатаем значение ошибки каждые print_step эпох 
};
save("-text","result/trn_par.txt", "trn_par" ) ;

[ W,er ] = cn_trn_gd(L,C,W,cfg,trn_par);
%[ W,er ] = cn_trn_rprop(L,C,W,cfg,trn_par);
%[ W,er ] = cn_trn_qprop(L,C,W,cfg,trn_par);

save("-text","result/w.txt", "W" ) ;
save("-text","result/er.txt", "er" ) ;
 
plot_error(er,0); % рисуем историю изменения ошибки обучения

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
printf("[i] тест                   \n");

printf("[i] загружаем данные\n"); 
T=data_load_img(ft); % L={ X,Y,img_size,files_list}
printf("[i] загружено тестовых: %i \n",size(T{2},2));

o = cn_run(T{1},W,cfg) ;
er = cn_loss(o,T{2},cfg) ;

save("-text","result/o.txt", "o" ) ;

[ p,n ]=max(o); % ответ (n) и вероятность принадлежности к классу (p)

n-=1 ;

save("-text","result/answ-n.txt", "n" ) ;
save("-text","result/answ-p.txt", "p" ) ;

[ v,vi ] = max(T{2}); % правильный ответ (vi)
v=(n!=(vi-1)); % ошибки

r=[ sum(v), length(v)];

printf("[i] ошибок на тесте %i из %i\n", r(1), r(2));

save("-text","result/answ-e.txt", "r" ) ;
save("-text","result/answ-ev.txt", "v" ) ;


