%!octave 
%
%       OS : GNU/Linux 4.2.5
% COMPILER : GNU Octave, version 4.0.0
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: main_maps.m,v 1.2 2016/04/21 14:06:58 mechanoid Exp $

addpath("../0-data-proc");

split_long_rows(0) ; % set nowrap


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
printf("[i] загружаем данные\n"); 

[fl,fc,ft ] = data_path_img();

L = data_load_img(fl); % L={ X,Y,img_size,files_list,num_chan}

printf("[i] загружено %i \n",size(L{2},2));


load("result/w.txt");
load("result/cfg.txt");

cn_print_cfg(cfg);

s = cn_state( L{1}, W, cfg ) ;

printf("[i] рисуем вход\n");
data_save_img(L{1},L{4},"result_maps/in") ;

for n=2:length(cfg),
   if strcmp("conv",cfg{n}{1}),  
	  p = sprintf("result_maps/l%i",n) ;

	  printf("[i] рисуем ядра слоя %i\n",n);
	  cn_kern_visualizer(W{n-1}{1},p);

	  printf("[i] рисуем карты слоя %i\n",n);
	  o = cn_activate( s{n}, cfg{n}{3} ) ; % активированный выход слоя
	  data_save_img(o,L{4},p) ;
   endif
endfor

