%!octave 
%
%      
%       OS : GNU/Linux 3.18.4-1-ARCH 
% COMPILER : GNU Octave, version 3.8.2
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: load_MNIST_images.m,v 1.2 2016/01/28 15:30:33 mechanoid Exp $


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% загрузка набора данных MNIST
% f - имя файла БД
%
function retval = load_MNIST_images(f),
   [ fid emsg ] = fopen(f,"r","ieee-be") ; % открываем файл БД на чтение
   if(fid<0) printf("[E] open: '%s' %s\n",f,emsg) ; exit -1; endif
   printf("[i] БД: %s\n",f) ;
   
   mnum = fread(fid,1,"int32") ; % проверяем magic number файла БД
   if(mnum~=2051) printf("[E] bad magic number\n") ; fclose(fid); exit -1; endif

   im_c = fread(fid,1,"int32") ; % количество образов в БД
   im_h = fread(fid,1,"int32") ; % высота картинки
   im_w = fread(fid,1,"int32") ; % ширина картинки

   % высота, ширина, канал, номер 
   I=zeros(im_h,im_w,1,im_c); % инициализируем структуру для данных
   for j=1:im_c, % для всех записей БД
	  x = uint8(fread(fid,[im_h im_w],"uchar"))' ; % считываем образ
	  I(:,:,1,j) = double(x)/255.0 ; % нормируем в [0,1]
	  printf( "[i] читаем запись  %i/%i        \r",j,im_c ) ;
   endfor

   printf("\n") ;
   fclose(fid) ;

   retval=I ;

endfunction 

